package ejb30.persistence.datatypes.client;

import javax.persistence.*;
import javax.ejb.*;
import javax.annotation.*;
import java.util.*;
import java.text.*;

import ejb30.persistence.datatypes.ejb.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class TestOutsideContainer {

    public static DataTypes dataRow[] = new DataTypes[3];
    public static String testSuiteID = "";
    private static SimpleReporterAdapter status = new SimpleReporterAdapter("appserver-sqe");
    public String dateString = "";
    public java.util.Date utildate = null;
    public java.sql.Date sqldate = null;
    public java.sql.Timestamp timestamp = null;
    public Locale currentLocale=new Locale("en","US");
    public DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT,currentLocale);

    public static void main(String[] args) {
  		if(args.length==1) {
                	 testSuiteID=args[0];
            	} 
	status.addDescription("Testing EJB 3.0 DataTypes ");
        TestOutsideContainer client = new TestOutsideContainer();
        client.run();
     	status.printSummary();
    }

    public void run() {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("manager", new HashMap());
        EntityManager manager = emf.createEntityManager();

        EntityTransaction tx = manager.getTransaction();
        tx.begin();
	  createDataTypes(manager);
	  readData(manager);
	  getAvgofShort(manager);
	  getAvgofByte(manager);
	  getAvgofLong(manager);
	  getAvgofFloat(manager);
	  getAvgofInteger(manager);
	  whereWithLong(manager);
	  whereWithShort(manager);
	  whereWithCharacter(manager);
	  maxRowSelection(manager);
	  utilDateSelection(manager);
	  sqlDateSelection(manager);
	  timeStampSelection(manager);
          updateRemoveData(manager);
        tx.commit();
        manager.close();
	emf.close();
    }

    public void createDataTypes(EntityManager manager)
    {
        SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
	try {
        	dateString = "09/15/76";
        	utildate = df.parse(dateString);
        	String date = "09-15-1979 15:52";
        	long timeInMillis = sdf.parse (date).getTime ();
        	timestamp=new java.sql.Timestamp(timeInMillis);
        	timestamp.setNanos(123000);
		dataRow[0] = new DataTypes(new Boolean(false),new Byte(Byte.MAX_VALUE),new Character ('a'),new Short(Short.MAX_VALUE),new Integer(1993),new Long(12345),new Float(Float.MAX_VALUE),utildate,new java.sql.Date(utildate.getTime()),timestamp);

        	dateString = "09/10/76";
        	utildate = df.parse(dateString);
            	timestamp.setNanos(124000);
        	dataRow[1] = new DataTypes(new Boolean(false),new Byte("101"),new Character ('b'),new Short("1001"),new Integer("1007"),new Long("1002"),new Float("1004"),utildate,new java.sql.Date(utildate.getTime()),timestamp);
        	dateString = "09/20/76";
        	utildate = df.parse(dateString);
            	timestamp.setNanos(125000);
        	dataRow[2] = new DataTypes(new Boolean(false),new Byte("0"),new Character ('c'),new Short("0"),new Integer("0"),new Long("0"),new Float("0"),utildate,new java.sql.Date(utildate.getTime()),timestamp);

		System.out.println("The testsuiteID is : " + testSuiteID);
                for (int i=0; i<3; i++ ) {
                    	manager.persist(dataRow[i]);
                    	manager.flush();
			System.out.println("The ID of the dataRow[i] " + dataRow[i].getId());
                 }
		 System.out.println(testSuiteID + " Create_row" + ": PASS");
        	 status.addStatus(testSuiteID + " Create_row", status.PASS);
      	} catch (ParseException e) {
          System.out.println(testSuiteID + " Create_row" + ": FAIL");
          status.addStatus(testSuiteID + " Create_row", status.FAIL);
 	  e.printStackTrace();
      	}
     }

     public void readData(EntityManager manager)
     {
     if(dataRow[0].getByteData().equals(new Byte(Byte.MAX_VALUE))){
       status.addStatus(testSuiteID + " Read_BYTE_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + " Read_BYTE_MAXVAL", status.FAIL);
     if(dataRow[0].getShortData().equals(new Short(Short.MAX_VALUE))){
       status.addStatus(testSuiteID + " Read_SHORT_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + " Read_SHORT_MAXVAL", status.FAIL);
     if(dataRow[0].getLongData().equals(new Long(12345))){
       status.addStatus(testSuiteID + " Read_LONG_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + " Read_LONG_MAXVAL", status.FAIL);
     if(dataRow[0].getIntegerData().equals(new Integer(1993))){
       status.addStatus(testSuiteID + " Read_INTEGER_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + " Read_INTEGER_MAXVAL", status.FAIL);
     }

     public void updateRemoveData(EntityManager manager)
     {
        DataTypes secondRow = manager.find(DataTypes.class, dataRow[1].getId());
     	try {
          secondRow.setBooleanData(new Boolean(true));
          System.out.println("The changed Boolean value is : " + secondRow.getBooleanData());
          System.out.println(testSuiteID + " Update_row: PASS");
          status.addStatus(testSuiteID + " Update_row ", status.PASS);
        } catch (Exception e) {
          System.out.println(testSuiteID + " Update_row: FAIL");
          System.out.println("Exception Caught: " + e );
          status.addStatus(testSuiteID + " Update_row ", status.FAIL);
        }

        DataTypes toDelete = manager.merge(secondRow);
	try {
      	  manager.remove(toDelete);
          System.out.println(testSuiteID + " Delete_row: PASS");
          status.addStatus(testSuiteID + " Delete_row ", status.PASS);
     	} catch (Exception e) {
          System.out.println(testSuiteID + " Delete_row: FAIL");
          System.out.println("Exception Caught: " + e );
          status.addStatus(testSuiteID + " Delete_row", status.FAIL);
        }
     }

     public void getAvgofShort(EntityManager manager)
     {
      	Double result = (Double)manager.createQuery("SELECT avg(d.shortData) from DataTypes d ").getSingleResult();
          System.out.println(testSuiteID + " Avgerage_ShortData : " + result);
        if(result==11256){
          status.addStatus(testSuiteID + " Average_ShortData ", status.PASS);
          } else status.addStatus(testSuiteID + " Average_ShortData ", status.FAIL);
     }
   
     public void getAvgofByte(EntityManager manager)
     {
      	Double result = (Double)manager.createQuery("SELECT avg(d.byteData) from DataTypes d ").getSingleResult();
          System.out.println(testSuiteID + " Avgerage_ByteData : " + result);
        if(result==76){
          status.addStatus(testSuiteID + " Average_ByteData ", status.PASS);
          } else status.addStatus(testSuiteID + " Average_ByteData ", status.FAIL);
     }
   
     public void getAvgofLong(EntityManager manager)
     {
	try {
      	  Double result = (Double)manager.createQuery("SELECT avg(d.longData) from DataTypes d ").getSingleResult();
          System.out.println(testSuiteID + " Avgerage_LongData : " + result);
          status.addStatus(testSuiteID + " Average_LongData ", status.PASS);
	} catch (Exception e) {
          status.addStatus(testSuiteID + " Average_LongData ", status.FAIL);
	}
     }
   
     public void getAvgofFloat(EntityManager manager)
     {
	try {
      	  Double result = (Double)manager.createQuery("SELECT avg(d.floatData) from DataTypes d ").getSingleResult();
          System.out.println(testSuiteID + " Avgerage_FloatData : " + result);
          status.addStatus(testSuiteID + " Average_FloatData ", status.PASS);
	} catch (Exception e) {
          status.addStatus(testSuiteID + " Average_FloatData ", status.FAIL);
	}
     }
   
     public void getAvgofInteger(EntityManager manager)
     {
      	Double result = (Double)manager.createQuery("SELECT avg(d.integerData) from DataTypes d ").getSingleResult();
          System.out.println(testSuiteID + " Avgerage_IntegerData : " + result);
        if(result==1000){
          status.addStatus(testSuiteID + " Average_IntegerData ", status.PASS);
          } else status.addStatus(testSuiteID + " Average_IntegerData ", status.FAIL);
     }

     public void whereWithLong(EntityManager manager)
     {
	try {
	  Long dataSearch = new Long("1002");
      	  List listResult = manager.createQuery("SELECT d from DataTypes d WHERE d.longData = :long").setParameter("long",dataSearch).getResultList();
      	  Iterator iter = listResult.iterator();
          while (iter.hasNext()) {
          	DataTypes c = (DataTypes)iter.next();
          	System.out.println("LongData = " + c.getLongData());
          	System.out.println("UtilDateData = " + c.getUtilDateData());
          	System.out.println("SQLDateData = " + c.getSqlDateData());
      	  }
          System.out.println(testSuiteID + " Query_Long : PASS");
          status.addStatus(testSuiteID + " Query_Long ", status.PASS);
        } catch (Exception e) {
      	  System.out.println(testSuiteID + " Query_Long : FAIL");
      	  System.out.println("Exception Caught: " + e );
      	  status.addStatus(testSuiteID + " Query_Long ", status.FAIL);
     	}

     }
   
     public void whereWithShort(EntityManager manager)
     {
	try {
	  Short dataSearch = new Short("1002");
      	  List listResult = manager.createQuery("SELECT d from DataTypes d WHERE d.shortData = :short").setParameter("short",dataSearch).getResultList();
      	  Iterator iter = listResult.iterator();
          while (iter.hasNext()) {
          	DataTypes c = (DataTypes)iter.next();
          	System.out.println("ShortData = " + c.getShortData());
      	  }
          System.out.println(testSuiteID + " Query_Short : PASS");
          status.addStatus(testSuiteID + " Query_Short ", status.PASS);
        } catch (Exception e) {
      	  System.out.println(testSuiteID + " Query_Short : FAIL");
      	  System.out.println("Exception Caught: " + e );
      	  status.addStatus(testSuiteID + " Query_Short ", status.FAIL);
     	}

     }

     public void whereWithCharacter(EntityManager manager)
     {
	try {
	  Character dataSearch = new Character('b');
      	  List listResult = manager.createQuery("SELECT d from DataTypes d WHERE d.characterData = :Character").setParameter("Character",dataSearch).getResultList();
      	  Iterator iter = listResult.iterator();
          while (iter.hasNext()) {
          	DataTypes c = (DataTypes)iter.next();
          	System.out.println("CharacterData = " + c.getCharacterData());
      	  }
          System.out.println(testSuiteID + " Query_Character : PASS");
          status.addStatus(testSuiteID + " Query_Character ", status.PASS);
        } catch (Exception e) {
      	  System.out.println(testSuiteID + " Query_Character : FAIL");
      	  System.out.println("Exception Caught: " + e );
      	  status.addStatus(testSuiteID + " Query_Character ", status.FAIL);
     	}

     }

     public void maxRowSelection(EntityManager manager)
     {
	try {
	  Integer dataSearch = new Integer("1");
      	  List listResult = manager.createQuery("SELECT d from DataTypes d WHERE d.id = :idn").setParameter("idn",dataSearch).getResultList();
          System.out.println(testSuiteID + " Query_Row_MAX_Value : PASS");
          status.addStatus(testSuiteID + " Query_Row_MAX_Value ", status.PASS);
        } catch (Exception e) {
      	  System.out.println(testSuiteID + " Query_Row_MAX_Value : FAIL");
      	  System.out.println("Exception Caught: " + e );
      	  status.addStatus(testSuiteID + " Query_Row_MAX_Value ", status.FAIL);
     	}

     }
   
     public void utilDateSelection(EntityManager manager)
     {
	try {
          dateString = "09/10/76";
          df= DateFormat.getDateInstance(DateFormat.SHORT,currentLocale);
          utildate = df.parse(dateString);
      	  List listResult = manager.createQuery("SELECT d from DataTypes d WHERE d.utilDateData = :utilDateParam").setParameter("utilDateParam",utildate).getResultList();
          System.out.println(testSuiteID + " Query_UtilDate : PASS");
          status.addStatus(testSuiteID + " Query_UtilDate ", status.PASS);
        } catch (Exception e) {
      	  System.out.println(testSuiteID + " Query_UtilDate : FAIL");
      	  System.out.println("Exception Caught: " + e );
      	  status.addStatus(testSuiteID + " Query_UtilDate ", status.FAIL);
     	}

     }
   
     public void sqlDateSelection(EntityManager manager)
     {
	try {
          dateString = "09/10/76";
          df= DateFormat.getDateInstance(DateFormat.SHORT,currentLocale);
          utildate = df.parse(dateString);
      	  sqldate=new java.sql.Date(utildate.getTime());
      	  List listResult = manager.createQuery("SELECT d from DataTypes d WHERE d.sqlDateData = :sqlDateParam").setParameter("sqlDateParam",sqldate).getResultList();
          System.out.println(testSuiteID + " Query_SqlDate : PASS");
          status.addStatus(testSuiteID + " Query_SqlDate ", status.PASS);
        } catch (Exception e) {
      	  System.out.println(testSuiteID + " Query_SqlDate : FAIL");
      	  System.out.println("Exception Caught: " + e );
      	  status.addStatus(testSuiteID + " Query_SqlDate ", status.FAIL);
     	}
     }

     public void timeStampSelection(EntityManager manager)
     {
	try {
          dateString = "09/10/76";
          df= DateFormat.getDateInstance(DateFormat.SHORT,currentLocale);
          utildate = df.parse(dateString);
          SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
          String date = "09-15-1979 15:52";
          long timeInMillis = sdf.parse(date).getTime();
          timestamp=new java.sql.Timestamp(timeInMillis);
          timestamp.setNanos(125000);

      	  List listResult = manager.createQuery("SELECT d from DataTypes d WHERE d.timeStampData = :timeStampParam").setParameter("timeStampParam",timestamp).getResultList();
          System.out.println(testSuiteID + " Query_SqlDate : PASS");
          status.addStatus(testSuiteID + " Query_SqlDate ", status.PASS);
        } catch (Exception e) {
      	  System.out.println(testSuiteID + " Query_SqlDate : FAIL");
      	  System.out.println("Exception Caught: " + e );
      	  status.addStatus(testSuiteID + " Query_SqlDate ", status.FAIL);
     	}
      }
}
