package ejb30.persistence.datatypes.ejb;

import javax.annotation.Resource;
import javax.ejb.*;
import javax.persistence.*;
import java.util.*;

@Stateless
public class DataTypesSessionBean implements DataTypesSession
{
   @PersistenceContext EntityManager manager;
   

   public int create(Boolean booleanData, Byte byteData, Character characterData, Short shortData, Integer integerData, Long longData, Float floatData, java.util.Date utilDateData, java.sql.Date sqlDateData, java.sql.Timestamp timeStampData)
   {
      DataTypes firstrow = new DataTypes(booleanData, byteData, characterData, shortData, integerData, longData, floatData, utilDateData, sqlDateData, timeStampData);
      manager.persist(firstrow);
      manager.flush();
      return firstrow.getId();
   }

   public DataTypes find(int id)
   {
      return manager.find(DataTypes.class, id);
   }

   public void remove(DataTypes del)
   {
      DataTypes toDelete = manager.merge(del);
      manager.remove(toDelete);
   }

   public Double getAvgofShort()
   {
      return (Double) manager.createQuery("SELECT avg(d.shortData) from DataTypes d ").getSingleResult();
   }
   
   public Double getAvgofByte()
   {
      return (Double) manager.createQuery("SELECT avg(d.byteData) from DataTypes d ").getSingleResult();
   }

   public Double getAvgofLong()
   {
      return (Double) manager.createQuery("SELECT avg(d.longData) from DataTypes d ").getSingleResult();
   }

   public Double getAvgofFloat()
   {
      return (Double) manager.createQuery("SELECT avg(d.floatData) from DataTypes d ").getSingleResult();
   }

   public Double getAvgofInteger()
   {
      return (Double) manager.createQuery("SELECT avg(d.integerData) from DataTypes d ").getSingleResult();
   }

   public List whereWithLong(long l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.longData = :long").setParameter("long",l).getResultList();

   }   

   public List whereWithShort(short l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.shortData = :short").setParameter("short",l).getResultList();
   }   

   public List whereWithInteger(Integer l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.integerData = :Integer").setParameter("Integer",l).getResultList();
   }   

   public List whereWithCharacter(Character l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.characterData = :Character").setParameter("Character",l).getResultList();
   }   

   public List whereWithByte(Byte l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.byteData = :Byte").setParameter("Byte",l).getResultList();
   }   

   public List whereWithFloat(Float l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.floatData = :Float").setParameter("Float",l).getResultList();
   }   

   public List utilDateSelection(java.util.Date l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.utilDateData = :utilDateParam").setParameter("utilDateParam",l).getResultList();
   }

   public List sqlDateSelection(java.sql.Date l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.sqlDateData = :sqlDateParam").setParameter("sqlDateParam",l).getResultList();
   }

   public List timeStampSelection(java.sql.Timestamp l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.timeStampData = :timeStampParam").setParameter("timeStampParam",l).getResultList();
      //return manager.createQuery("SELECT d from DataTypes d WHERE d.id = 1").getResultList();
   }

   public void merge(DataTypes d)
   {
      manager.merge(d);
   }
   
}
